/* $Revision: 1 $ */
/* $Date: 11/14/03 11:30a $ */
/*
*	This header defines HPDI32 API extensions for use with the PRINT variation
*	of the HPDI32.
*/
/* $Log: /NEW SOURCESAFE DATABASE/PLX SDK 4.0.0 Drivers - Don/gsc/hpdi32/Win32/print/hpdi32_api_print.h $
 * 
 * 1     11/14/03 11:30a Dnewbold
*/

#ifndef __HPDI32_API_PRINT_H__
#define __HPDI32_API_PRINT_H__

#include "hpdi32_api.h"

#ifdef __cplusplus
extern "C" {
#endif



/* #defines	*****************************************************************/

#define	HPDI32_PRINT_FRR		HPDI32_REG_ENCODE(4, 0x00)
#define	HPDI32_PRINT_BCR		HPDI32_REG_ENCODE(4, 0x04)
#define	HPDI32_PRINT_BSR		HPDI32_REG_ENCODE(4, 0x08)
#define	HPDI32_PRINT_TAR		HPDI32_REG_ENCODE(4, 0x0C)
#define	HPDI32_PRINT_FDR		HPDI32_REG_ENCODE(4, 0x18)
#define	HPDI32_PRINT_HSSR		HPDI32_REG_ENCODE(4, 0x20)
#define	HPDI32_PRINT_ICR		HPDI32_REG_ENCODE(4, 0x30)
#define	HPDI32_PRINT_ISR		HPDI32_REG_ENCODE(4, 0x34)
#define	HPDI32_PRINT_PCSR		HPDI32_REG_ENCODE(4, 0x40)
#define	HPDI32_PRINT_ESR		HPDI32_REG_ENCODE(4, 0x44)
#define	HPDI32_PRINT_HDHR		HPDI32_REG_ENCODE(4, 0x48)
#define	HPDI32_PRINT_QTDCR		HPDI32_REG_ENCODE(4, 0x4C)
#define	HPDI32_PRINT_STARTPR	HPDI32_REG_ENCODE(4, 0x50)
#define	HPDI32_PRINT_STOPPR		HPDI32_REG_ENCODE(4, 0x54)
#define	HPDI32_PRINT_CPR		HPDI32_REG_ENCODE(4, 0x58)
#define	HPDI32_PRINT_H0FDR		HPDI32_REG_ENCODE(4, 0x80)
#define	HPDI32_PRINT_H0FWR		HPDI32_REG_ENCODE(4, 0x84)
#define	HPDI32_PRINT_H1FDR		HPDI32_REG_ENCODE(4, 0x88)
#define	HPDI32_PRINT_H1FWR		HPDI32_REG_ENCODE(4, 0x8C)
#define	HPDI32_PRINT_H2FDR		HPDI32_REG_ENCODE(4, 0x90)
#define	HPDI32_PRINT_H2FWR		HPDI32_REG_ENCODE(4, 0x94)
#define	HPDI32_PRINT_H3FDR		HPDI32_REG_ENCODE(4, 0x98)
#define	HPDI32_PRINT_H3FWR		HPDI32_REG_ENCODE(4, 0x9C)
#define	HPDI32_PRINT_H4FDR		HPDI32_REG_ENCODE(4, 0xA0)
#define	HPDI32_PRINT_H4FWR		HPDI32_REG_ENCODE(4, 0xA4)
#define	HPDI32_PRINT_H5FDR		HPDI32_REG_ENCODE(4, 0xA8)
#define	HPDI32_PRINT_H5FWR		HPDI32_REG_ENCODE(4, 0xAC)
#define	HPDI32_PRINT_H6FDR		HPDI32_REG_ENCODE(4, 0xB0)
#define	HPDI32_PRINT_H6FWR		HPDI32_REG_ENCODE(4, 0xB4)
#define	HPDI32_PRINT_H7FDR		HPDI32_REG_ENCODE(4, 0xB8)
#define	HPDI32_PRINT_H7FWR		HPDI32_REG_ENCODE(4, 0xBC)



/* Register field masks. */

/* GSC: Board Control Register */
#define	HPDI32_PRINT_BCR_BOARD_RESET		0x00000001	/* Needs 10us pause. */
#define	HPDI32_PRINT_BCR_TX_FIFO_RESET		0x00000002
#define	HPDI32_PRINT_BCR_TX_ENABLED			0x00000010
#define	HPDI32_PRINT_BCR_TX_START			0x00000100

/* GSC: Board Status Register */
#define	HPDI32_PRINT_BSR_EAI				0x00000004
#define	HPDI32_PRINT_BSR_EBI				0x00000008
#define	HPDI32_PRINT_BSR_ZFWDI				0x00000010
#define	HPDI32_PRINT_BSR_ZREFI				0x00000020

#define	HPDI32_PRINT_BSR_TX_MASK			0x00000F00
#define	HPDI32_PRINT_BSR_TX_NOT_EMPTY		0x00000100
#define	HPDI32_PRINT_BSR_TX_NOT_AE			0x00000200
#define	HPDI32_PRINT_BSR_TX_NOT_AF			0x00000400
#define	HPDI32_PRINT_BSR_TX_NOT_FULL		0x00000800

/* GSC: Tx Almost Register */
#define	HPDI32_PRINT_ALMOST_ENCODE(f,e)		HPDI32_ALMOST_ENCODE(f,e)

#define	HPDI32_PRINT_DECODE_EMPTY(r)		HPDI32_DECODE_EMPTY(r)
#define	HPDI32_PRINT_DECODE_FULL(r)			HPDI32_DECODE_FULL(r)

/* GSC: Tx Almost Register */
#define	HPDI32_PRINT_TAR_ENCODE(f,e)		HPDI32_PRINT_ALMOST_ENCODE((f),(e))
#define	HPDI32_PRINT_TAR_DECODE_EMPTY(r)	HPDI32_PRINT_DECODE_EMPTY((r))
#define	HPDI32_PRINT_TAR_DECODE_FULL(r)		HPDI32_PRINT_DECODE_FULL((r))

/* GSC: Head Shift Size Register */
#define	HPDI32_PRINT_HSSR_SIZE_DECODE(r)	GSC_FIELD_DECODE(r,7,0)
#define	HPDI32_PRINT_HSSR_SIZE_ENCODE(v)	GSC_FIELD_ENCODE(v,7,0)

/* GSC: Interrupt Control Register */
#define	HPDI32_PRINT_ICR_TX_E				0x00000100	/* Tx FIFO Empty */
#define	HPDI32_PRINT_ICR_TX_AE				0x00000200	/* Tx FIFO Almost Empty */
#define	HPDI32_PRINT_ICR_TX_AF				0x00000400	/* Tx FIFO Almost Full */
#define	HPDI32_PRINT_ICR_TX_F				0x00000800	/* Tx FIFO Full */

/* GSC: Interrupt Status Register */
#define	HPDI32_PRINT_ISR_PRINT				0x00000001	/* from PCSR */
#define	HPDI32_PRINT_ISR_TX_E				0x00000100	/* Tx FIFO Empty */
#define	HPDI32_PRINT_ISR_TX_AE				0x00000200	/* Tx FIFO Almost Empty */
#define	HPDI32_PRINT_ISR_TX_AF				0x00000400	/* Tx FIFO Almost Full */
#define	HPDI32_PRINT_ISR_TX_F				0x00000800	/* Tx FIFO Full */

/* GSC: Printing Control/Status Register */
#define	HPDI32_PRINT_PCSR_QEIE				0x00000001
#define	HPDI32_PRINT_PCSR_ZFWDRIE			0x00000002
#define	HPDI32_PRINT_PCSR_ZREVRIE			0x00000004
#define	HPDI32_PRINT_PCSR_STOPRIE			0x00000008
#define	HPDI32_PRINT_PCSR_DTPE				0x00000200
#define	HPDI32_PRINT_PCSR_ITIE				0x00000800
#define	HPDI32_PRINT_PCSR_ZFWDT				0x00001000
#define	HPDI32_PRINT_PCSR_ZREVT				0x00002000
#define	HPDI32_PRINT_PCSR_AT				0x00004000
#define	HPDI32_PRINT_PCSR_BT				0x00008000
#define	HPDI32_PRINT_PCSR_QEED				0x00010000
#define	HPDI32_PRINT_PCSR_ZFWDD				0x00020000
#define	HPDI32_PRINT_PCSR_ZREVD				0x00040000
#define	HPDI32_PRINT_PCSR_STOPR				0x00080000
#define	HPDI32_PRINT_PCSR_FZFWDI			0x00100000
#define	HPDI32_PRINT_PCSR_FZREVI			0x00200000
#define	HPDI32_PRINT_PCSR_FAI				0x00400000
#define	HPDI32_PRINT_PCSR_FBI				0x00800000

#define	HPDI32_PRINT_PCSR_FS_DECODE(r)		(GSC_FIELD_DECODE(r,5,4) + 2)
#define	HPDI32_PRINT_PCSR_FS_ENCODE(v)		GSC_FIELD_ENCODE((v)-2,5,4)

#define	HPDI32_PRINT_PCSR_FS_2				2
#define	HPDI32_PRINT_PCSR_FS_3				3
#define	HPDI32_PRINT_PCSR_FS_4				4
#define	HPDI32_PRINT_PCSR_FS_5				5

/* GSC: Edge Selector Register */
#define	HPDI32_PRINT_ESR_CPCZFWDR			0x00000001
#define	HPDI32_PRINT_ESR_CPCZFWDF			0x00000002
#define	HPDI32_PRINT_ESR_CPCZREVR			0x00000003
#define	HPDI32_PRINT_ESR_CPCZREVF			0x00000004
#define	HPDI32_PRINT_ESR_STARTZFWDR			0x00000010
#define	HPDI32_PRINT_ESR_STARTZFWDF			0x00000020
#define	HPDI32_PRINT_ESR_STARTZREVR			0x00000040
#define	HPDI32_PRINT_ESR_STARTZREVF			0x00000080
#define	HPDI32_PRINT_ESR_STARTLOC			0x00000100
#define	HPDI32_PRINT_ESR_STOPZFWDR			0x00000200
#define	HPDI32_PRINT_ESR_STOPZFWDF			0x00000400
#define	HPDI32_PRINT_ESR_STOPZREVR			0x00000800
#define	HPDI32_PRINT_ESR_STOPZREVF			0x00001000
#define	HPDI32_PRINT_ESR_STOPLOC			0x00002000
#define	HPDI32_PRINT_ESR_FHAR				0x00004000
#define	HPDI32_PRINT_ESR_FHAF				0x00008000
#define	HPDI32_PRINT_ESR_FHBR				0x00010000
#define	HPDI32_PRINT_ESR_FHBF				0x00020000
#define	HPDI32_PRINT_ESR_DSSLDR				0x00040000
#define	HPDI32_PRINT_ESR_DSSLDF				0x00080000
#define	HPDI32_PRINT_ESR_DSZFWDDR			0x00100000
#define	HPDI32_PRINT_ESR_DSZREVDF			0x00200000

/* GSC: Head Data Holdoff Register */
#define	HPDI32_PRINT_HDHR_COUNT_DECODE(r)	GSC_FIELD_DECODE(r,11,0)
#define	HPDI32_PRINT_HDHR_COUNT_ENCODE(v)	GSC_FIELD_ENCODE(v,11,0)

/* GSC: Quadrature Transition Delay Count Register */
#define	HPDI32_PRINT_QTDCR_COUNT_DECODE(r)	GSC_FIELD_DECODE(r,11,0)
#define	HPDI32_PRINT_QTDCR_COUNT_ENCODE(v)	GSC_FIELD_ENCODE(v,11,0)

/* GSC: Start Position Register */
#define	HPDI32_PRINT_STARTPR_POS_DECODE(r)	GSC_FIELD_DECODE(r,19,0)
#define	HPDI32_PRINT_STARTPR_POS_ENCODE(v)	GSC_FIELD_ENCODE(v,19,0)

/* GSC: Stop Position Register */
#define	HPDI32_PRINT_STOPPR_POS_DECODE(r)	GSC_FIELD_DECODE(r,19,0)
#define	HPDI32_PRINT_STOPPR_POS_ENCODE(v)	GSC_FIELD_ENCODE(v,19,0)

/* GSC: Current Position Register */
#define	HPDI32_PRINT_CPR_POS_DECODE(r)		GSC_FIELD_DECODE(r,19,0)

/* GSC: Head X Fire Delay Register */
#define	HPDI32_PRINT_HXFDR_DELAY_DECODE(r)	GSC_FIELD_DECODE(r,11,0)
#define	HPDI32_PRINT_HXFDR_DELAY_ENCODE(v)	GSC_FIELD_ENCODE(v,11,0)

/* GSC: Head X Fire Width Register */
#define	HPDI32_PRINT_HXFWR_WIDTH_DECODE(r)	GSC_FIELD_DECODE(r,11,0)
#define	HPDI32_PRINT_HXFWR_WIDTH_ENCODE(v)	GSC_FIELD_ENCODE(v,11,0)



#ifdef __cplusplus
}
#endif

#endif
